## sra-sdk 2.3.3-4~dfsg

=== debian/changelog ===
sra-sdk (2.3.3-4~dfsg-1) unstable; urgency=low

  [ Andreas Tille ]
  * New upstream version
  * debian/upstream: Add citation information
  * fix debian/watch
  * debian/control:
     - cme fix dpkg-control
     - debhelper 9
     - canonical Vcs fields
  * debian/copyright: Exclude external libraries
  * debian/rules:
     - Add get-orig-source target to call enhances uscan
     - remove override because upstream seems to do the correct thing now
     - libsra-schema seems to be not built any more in this version so
       drop the special handling of it
     - Reactivate deletion of libs/krypto/*.pic.o.list files to get a
       really clean source
  * debian/doc: USAGE is not provided by upstream any more
  * debian/patches/build-with-system-libbz2-libz.patch: Fix build problem
    (thanks to Gert Wollny <gw.fossdev@gmail.com> for the patch)
  * debian/sra-toolkit.install: There are neither mod?? nor wmod?? files
    shipped in this version any more - so remove these from dh_install
  * debian/patches/hardening.patch: Propagate Debian hardening options
    into build system
  * debian/patches/hardening-format-security.patch: Fix format strings in
    snprintf() calls
  * debian/watch: mangle version string
  * debian/sra-toolkit-libs0.lintian-overrides: override
    package-name-doesnt-match-sonames

  [ Charles Plessy ]
  32dd5cd Updated symbols file.

 -- Andreas Tille <tille@debian.org>  Wed, 23 Oct 2013 10:43:20 +0200
